diff --git a/src/main/java/net/minecraft/core/net/packet/UseItemPacket.java b/src/main/java/net/minecraft/core/net/packet/UseItemPacket.java
index 1747885cd..e3b7f6bae 100644
--- a/src/main/java/net/minecraft/core/net/packet/UseItemPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/UseItemPacket.java
@@ -14,15 +14,23 @@ import net.minecraft.core.util.helper.Direction;
 public class UseItemPacket extends Packet
 {
 
+    public int xPosition;
+    public int yPosition;
+    public int zPosition;
+    public Direction direction;
+    public double xPlaced;
+    public double yPlaced;
+    public ItemStack itemStack;
+
     public UseItemPacket()
     {
     }
 
-    public UseItemPacket(int i, int j, int k, Direction direction, ItemStack itemstack, double xPlaced, double yPlaced)
+    public UseItemPacket(int x, int y, int z, Direction direction, ItemStack itemstack, double xPlaced, double yPlaced)
     {
-        xPosition = i;
-        yPosition = j;
-        zPosition = k;
+        xPosition = x;
+        yPosition = y;
+        zPosition = z;
         this.direction = direction;
         itemStack = itemstack;
         this.xPlaced = xPlaced;
@@ -83,12 +91,4 @@ public class UseItemPacket extends Packet
     {
         return 19;
     }
-
-    public int xPosition;
-    public int yPosition;
-    public int zPosition;
-    public Direction direction;
-    public double xPlaced;
-    public double yPlaced;
-    public ItemStack itemStack;
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java b/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java
index 541a829bd..7bed0c445 100644
--- a/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java
+++ b/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java
@@ -73,7 +73,7 @@ public class Inventory
         currentItem = index;
     }
     
-    public static int func_25054_e()
+    public static int playerMainInventorySize()
     {
         return 9 * 4;
     }
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
index 0611efd83..725c99f51 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
@@ -54,19 +54,19 @@ public abstract class AbstractContainerMenu
 		else
 		{
 			containerListeners.add(containerListener);
-			containerListener.updateCraftingInventory(this, func_28127_b());
+			containerListener.updateCraftingInventory(this, getSlotStackList());
 			broadcastChanges();
 		}
 	}
 
-	public List<ItemStack> func_28127_b()
+	public List<ItemStack> getSlotStackList()
 	{
-		List<ItemStack> arraylist = new ArrayList<>();
-		for (Slot inventorySlot : slots) {
-			arraylist.add(inventorySlot.getItem());
+		List<ItemStack> itemList = new ArrayList<>();
+		for (Slot slot : slots) {
+			itemList.add(slot.getItem());
 		}
 
-		return arraylist;
+		return itemList;
 	}
 
 
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java
index 9a8ae7979..e43e805d9 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java
@@ -3,6 +3,7 @@ package net.minecraft.core.player.inventory.menu;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.container.CraftingContainer;
@@ -39,8 +40,8 @@ public class InventoryMenu extends AbstractContainerMenu {
 		}
 		
 		for (int i = 0; i < 4; i++) {
-			int j1 = i;
-			addSlot(new ArmorSlot(this, inventory, inventory.getContainerSize() - 1 - i, 8, 8 + i * 18, j1));
+			int armorType = IArmorItem.PIECE_HEAD - i;
+			addSlot(new ArmorSlot(this, inventory, inventory.getContainerSize() - 1 - i, 8, 8 + i * 18, armorType));
 		}
 		
 		for (int i = 0; i < 3; i++) {
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
index 23483ddae..20b34fd84 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
@@ -18,10 +18,10 @@ import java.util.Set;
 public class ArmorSlot extends Slot
 {
     public static String[] armorOutlines = new String[]{
-            "minecraft:item/armor_helmet_outline",
-            "minecraft:item/armor_chestplate_outline",
-            "minecraft:item/armor_leggings_outline",
-            "minecraft:item/armor_boots_outline"
+        "minecraft:item/armor_boots_outline",
+        "minecraft:item/armor_leggings_outline",
+        "minecraft:item/armor_chestplate_outline",
+        "minecraft:item/armor_helmet_outline"
     };
 
     final int armorType;
diff --git a/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index 5dfdac277..f757fa6ed 100644
--- a/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -40,6 +40,12 @@ public class MathHelper
         return d >= (double)truncated ? truncated : truncated - 1;
     }
 
+    public static int ceil(double d)
+    {
+        int truncated = (int)d;
+        return d == (double)truncated ? truncated : truncated + 1;
+    }
+
     public static int round(double d) {
         int truncated = (int) d;
         return d <= truncated + 0.5 ? truncated : truncated + 1;
diff --git a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index 0ffb886b1..4770942a2 100644
--- a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -157,7 +157,7 @@ public class ExplosionCannonball extends Explosion{
                 d3 /= d6;
                 d4 /= d6;
                 d5 /= d6;
-                double d7 = 0.5D / (d6 / (double)explosionSize + 0.10000000000000001D);
+                double d7 = 0.5D / (d6 / (double)explosionSize + 0.1D);
                 d7 *= worldObj.rand.nextFloat() * worldObj.rand.nextFloat() + 0.3F;
                 d3 *= d7;
                 d4 *= d7;
diff --git a/src/main/java/net/minecraft/core/world/LevelListener.java b/src/main/java/net/minecraft/core/world/LevelListener.java
index 9cf700e2a..1ee3a7475 100644
--- a/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -11,16 +11,46 @@ import net.minecraft.core.sound.SoundCategory;
 
 public interface LevelListener
 {
-    public static final int EVENT_DISPENSER_ITEM = 1000;
-    public static final int EVENT_DISPENSER_EMPTY = 1001;
-    public static final int EVENT_DISPENSER_PROJECTILE = 1002;
-    public static final int EVENT_DOOR_SOUND = 1003;
-    public static final int EVENT_DISPENSER_PARTICLES = 2000;
-    public static final int EVENT_BLOCK_BREAK = 2001;
-    public static final int EVENT_FIRE_EXTINGUISH = 1004;
-    public static final int EVENT_JUKEBOX_TOGGLE = 1005;
-    public static final int EVENT_PISTON_EXTEND = 1006;
-    public static final int EVENT_PISTON_RETRACT = 1007;
+    /**
+     * data: unused
+     */
+    int EVENT_DISPENSER_ITEM = 1000;
+    /**
+     * data: unused
+     */
+    int EVENT_DISPENSER_EMPTY = 1001;
+    /**
+     * data: unused
+     */
+    int EVENT_DISPENSER_PROJECTILE = 1002;
+    /**
+     * data: unused
+     */
+    int EVENT_DOOR_SOUND = 1003;
+    /**
+     * data: {@link net.minecraft.core.util.helper.Direction Direction} id for the direction particles should be ejected
+     */
+    int EVENT_DISPENSER_PARTICLES = 2000;
+    /**
+     * data: block ID of the particles to create
+     */
+    int EVENT_BLOCK_BREAK = 2001;
+    /**
+     * data: unused
+     */
+    int EVENT_FIRE_EXTINGUISH = 1004;
+    /**
+     * data: item ID of the music disc to play, 0 to stop playback
+     */
+    int EVENT_JUKEBOX_TOGGLE = 1005;
+    /**
+     * data: unused
+     */
+    int EVENT_PISTON_EXTEND = 1006;
+    /**
+     * data: unused
+     */
+    int EVENT_PISTON_RETRACT = 1007;
 
 	/**
 	 * Redraw block in singleplayer and send block change packet in multiplayer. <br>
diff --git a/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 378da74f8..59e1f0af1 100644
--- a/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -20,6 +20,7 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinate;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.ChunkPosition;
+import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.pathfinder.Node;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
@@ -297,7 +298,7 @@ public final class SpawnerMobs
 									entity.spawnInit();
 									world.entityJoinedWorld(entity);
 									player.wakeUpPlayer(true, false);
-									world.playBlockEvent(null, 2001, (int) player.x, (int) player.y - 1, (int) player.z, world.getBlockId((int) player.x, (int) player.y - 1, (int) player.z));
+									world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, (int) player.x, (int) player.y - 1, (int) player.z, world.getBlockId((int) player.x, (int) player.y - 1, (int) player.z));
 									entity.playLivingSound();
 									spawnedEntity = true;
 									spawnedEntityForPlayer = true;
@@ -311,38 +312,4 @@ public final class SpawnerMobs
 		}
 		return spawnedEntity;
 	}
-    public static class SpawnerConfig {
-        private boolean allowPassive = true;
-        private boolean allowHostile = true;
-        private final Map<String, Boolean> mobSpawnOverrides = new HashMap<>();
-
-        public boolean canPassiveSpawn(World world) {
-            return allowPassive;
-        }
-
-        public void setPassiveSpawning(boolean flag) {
-            allowPassive = flag;
-        }
-
-        public boolean canHostileSpawn(World world) {
-            return allowHostile && world.getDifficulty().canHostileMobsSpawn();
-        }
-
-        public void setHostileSpawning(boolean flag) {
-            allowHostile = flag;
-        }
-
-        public boolean canMobSpawn(String mobID) {
-            return mobSpawnOverrides.getOrDefault(mobID.toLowerCase(Locale.ROOT), true);
-        }
-
-        public void setMobSpawn(String mobID, boolean flag) {
-            mobSpawnOverrides.put(mobID.toLowerCase(Locale.ROOT), flag);
-        }
-
-        public Collection<Map.Entry<String, Boolean>> getSpawnEntries() {
-            return mobSpawnOverrides.entrySet();
-        }
-    }
-
 }
